/***************************************************************************
 $RCSfile: msgengine.h,v $
                             -------------------
    cvs         : $Id: msgengine.h,v 1.2 2005/02/13 04:02:32 aquamaniac Exp $
    begin       : Mon Mar 01 2004
    copyright   : (C) 2004 by Martin Preuss
    email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/


#ifndef CHIPCARD_CLIENT_MSGENGINE_H
#define CHIPCARD_CLIENT_MSGENGINE_H

#ifdef __cplusplus
extern "C" {
#endif

#include <gwenhywfar/msgengine.h>
#include <chipcard2/chipcard2.h>

/**
 * @file msgengine_l.h
 *
 * This message engine implements a few new types:
 * <ul>
 *   <li>byte</li>
 *   <li>word (bigEndian="1")</li>
 *   <li>dword (bigEndian="1")</li>
 *   <li>bytes (size="-1") </li>
 *   <li>tlv (tlvType="BER"||"SIMPLE") </li>
 * </ul>
 */

CHIPCARD_API
GWEN_MSGENGINE *LC_MsgEngine_new();


#ifdef __cplusplus
}
#endif


#endif /* CHIPCARD_CLIENT_MSGENGINE_H */


